services:
  dev:
    image: busybox
    depends_on:
      - caddy
      - dns
      - mailpit
      - redis-cache
      - redis-queue
      - keycloak
      - postgres
      - postgres-keycloak

  caddy:
    image: caddy:latest
    restart: unless-stopped
    network_mode: host
    platform: linux/amd64
    env_file:
      - ../.env
    volumes:
      - ../.devcontainer/Caddyfile:/etc/caddy/Caddyfile
      - caddy-data:/data
      - caddy-config:/config

  dns:
    restart: unless-stopped
    image: registry.gitlab.com/bitspur/multiplatform.one/multiplatform.one/dns:latest
    network_mode: host
    cap_add:
      - NET_ADMIN
    env_file:
      - ../.env

  mailpit:
    image: axllent/mailpit
    restart: unless-stopped
    volumes:
      - mailpit:/data
    ports:
      - 8025:8025
      - 1025:1025
    environment:
      MP_MAX_MESSAGES: 5000
      MP_DATA_FILE: /data/mailpit.db
      MP_SMTP_AUTH_ACCEPT_ANY: 1
      MP_SMTP_AUTH_ALLOW_INSECURE: 1

  redis-cache:
    image: docker.io/redis:alpine
    restart: unless-stopped
    ports:
      - 6379:6379

  redis-queue:
    image: docker.io/redis:alpine
    restart: unless-stopped
    ports:
      - 6380:6379

  keycloak:
    container_name: keycloak
    restart: unless-stopped
    platform: linux/amd64
    image: registry.gitlab.com/bitspur/rock8s/images/keycloak:25.0.1
    ports:
      - 8080:8080
    volumes:
      - ../platforms/keycloak/docker/realm-export.json:/opt/keycloak/data/import/realm-export.json:ro
    command:
      - start
      - --import-realm
      - --optimized
    environment:
      KC_DB_URL_DATABASE: postgres
      KC_DB_URL_HOST: postgres-keycloak
      KC_DB_URL_PASSWORD: postgres
      KC_DB_URL_USERNAME: postgres
      KEYCLOAK_ADMIN: admin
      KEYCLOAK_ADMIN_PASSWORD: P@ssw0rd
    depends_on:
      - postgres-keycloak

  postgres:
    container_name: postgres
    restart: unless-stopped
    image: postgres:14.5
    ports:
      - 5432:5432
    environment:
      POSTGRES_DATABASE: postgres
      POSTGRES_PASSWORD: postgres
      POSTGRES_USER: postgres
    volumes:
      - postgres:/var/lib/postgresql/data

  postgres-keycloak:
    container_name: postgres-keycloak
    restart: unless-stopped
    image: postgres:14.5
    environment:
      POSTGRES_DATABASE: postgres
      POSTGRES_PASSWORD: postgres
      POSTGRES_USER: postgres
    volumes:
      - postgres-keycloak:/var/lib/postgresql/data

volumes:
  caddy-config: {}
  caddy-data: {}
  mailpit: {}
  postgres-keycloak: {}
  postgres: {}
